class IntroScene extends Phaser.Scene {
    constructor() {
        super("introScene");
    }
    preload() {
        preloadgraf(this);
        this.load.image("bgintro1", "assets/images/IMAGEM_ENTRADA.png");
        this.load.image("avancar", "assets/images/AVANCAR_01.png");
        this.load.image("avancar_on", "assets/images/AVANCAR_02.png");
        this.load.image("barra_icons", "assets/images/BARRA_ARRASTA.png");
        this.load.image("tabela_bmp", "assets/images/tabela.png");
        this.load.image("kg", "assets/images/kg.png");
        this.load.image("d0", "assets/images/d0.png");
        this.load.image("d1", "assets/images/d1.png");
        this.load.image("d2", "assets/images/d2.png");
        this.load.image("d3", "assets/images/d3.png");
        this.load.image("d4", "assets/images/d4.png");
        this.load.image("d5", "assets/images/d5.png");
        this.load.image("d6", "assets/images/d6.png");
        this.load.image("d7", "assets/images/d7.png");
        this.load.image("d8", "assets/images/d8.png");
        this.load.image("d9", "assets/images/d9.png");
        this.load.svg("logo", "assets/images/PRP_LOGO.svg", {
            scale: 1,
        });
        this.load.svg("icon_masculino", "assets/images/MASCULINO.svg", {
            scale: 1,
        });
        this.load.svg("icon_feminino", "assets/images/FEMININO.svg", {
            scale: 1,
        });
        this.load.svg("balanca", "assets/images/BALANCA.svg", {
            scale: 1,
        });
        this.load.svg("refeicao", "assets/images/REFEICAO.svg", {
            scale: 1,
        });
        this.load.svg("bt_down1", "assets/images/BOTAO_DOWN_01.svg", {
            scale: 1,
        });
        this.load.svg("bt_up1", "assets/images/BOTAO_UP_01.svg", {
            scale: 1,
        });
        this.load.svg("simboloMais", "assets/images/SIMBOLO_MAIS.svg", {
            scale: 1,
        });
        this.load.svg("copo_vinho", "assets/images/COPO_VINHO.svg", {
            scale: 1,
        });
        this.load.svg("cerveja", "assets/images/CERVEJA.svg", {
            scale: 1,
        });
        this.load.svg("shoot", "assets/images/SHOOT.svg", {
            scale: 1,
        });
    }
    create() {
        this.add.image(0, 0, "bgintro1").setOrigin(0);
        var difY = 140;
        this.add.image(0, 0, "bgintro1").setOrigin(0);
        this.add.image(249, 786, "barra_icons").setOrigin(0);
        this.label1 = this.add
            .text(92, 77, ["ALCOHOL CONTENT", "SIMULATOR"], {
                fontFamily: fontTxt1,
                fill: "#ffffff",
                align: "left",
            })
            .setOrigin(0)
            .setFontSize(80)
            .setShadow(2, 2, "rgba(0,0,0,0.5)", 0);
        this.label2 = this.add
            .text(
                this.label1.x,
                this.label1.y + this.label1.height,
                [
                    "IN THIS SIMULATOR YOU CAN INTERACTIVELY",
                    "TEST THE EFFECTS OF ALCOHOL CONSUMPTION",
                    "OVER A PERIOD OF TIME.",
                ],
                {
                    fontFamily: fontTxt1,
                    fill: "#000000",
                    align: "left",
                }
            )
            .setOrigin(0)
            .setFontSize(30);
        this.btavancar = new Button2(
            config.scale.width - 75,
            797,
            "avancar",
            "avancar_on",
            this,
            () => this.clickavancar()
        );
        this.separador = this.add
            .rectangle(
                0,
                0,
                config.scale.width,
                config.scale.height,
                CORES.branco
            )
            .setOrigin(0)
            .setAlpha(0)
            .setInteractive();
    }
    clickavancar() {
        this.btavancar.desactivar();
        this.tweens.add({
            targets: this.separador,
            alpha: 1,
            duration: 50,
            onComplete: this.avancar.bind(this),
        });
    }
    avancar() {
        this.scene.start("jogoScene");
    }
}
class Controller extends Phaser.Scene {
    constructor() {
        super("jogoScene");
        this.var_genero; //Homem Mulher (H, M)
        this.var_peso;
        this.var_refeicao;
        this.var_bebidasPerTempo = [];
        this.listaObjCopos = [];
        this.var_index = 0;
        this.bthomem;
        this.btmulher;
        this.bt_comrefeicao;
        this.bt_semrefeicao;
        this.grafico;
        this.displaypeso;
        this.timeline = [
            "start",
            "15 min",
            "30 min",
            "45 min",
            "1 hour",
            "1 h 15 min",
            "1 h 30 min",
            "1 h 45 min",
            "2 hours",
            "2 h 15 min",
            "2 h 30 min",
            "2 h 45 min",
        ];
        this.BETA = 0.1; //g/L/h
        this.w_escolhaBebida;
        this.w_escolhaPeso;
    }
    create() {
        this.add.image(249, 786, "barra_icons").setOrigin(0);
        this.add
            .rectangle(0, 0, config.scale.width, 773, CORES.verdemar, 1)
            .setOrigin(0);
        this.add.rectangle(22, 21, 274, 222, CORES.branco, 1).setOrigin(0);
        var rect2 = this.add
            .rectangle(741, 21, 571, 222, CORES.branco, 1)
            .setOrigin(0);
        this.add.rectangle(1363, 21, 184, 222, CORES.branco, 1).setOrigin(0);
        this.add.image(346, 21, "tabela_bmp").setOrigin(0);
        this.bthomem = new Button2(
            101,
            80,
            "icon_masculino",
            "icon_masculino",
            this,
            () => this.mudaGenero("H"),
            2
        );
        this.bthomem.changespr(2);
        this.btmulher = new Button2(
            226,
            80,
            "icon_feminino",
            "icon_feminino",
            this,
            () => this.mudaGenero("M"),
            2
        );
        this.btmulher.changespr(2);
        this.add.image(71, 198, "balanca").setOrigin(0.5);
        this.add.image(237, 197, "kg").setOrigin(0.5);
        var aa = this.add
            .rectangle(120, 172, 81, 52, CORES.verdealface, 1)
            .setOrigin(0);
        this.displaypeso = this.add
            .text(aa.x + aa.width * 0.5, aa.y + aa.height * 0.5, "0", {
                fontFamily: "GothamBold",
                align: "center",
            })
            .setTint(CORES.branco)
            .setOrigin(0.5)
            .setFontSize(28)
            .setInteractive({
                useHandCursor: true,
            })
            .on("pointerover", () => this.displaypeso.setScale(1.1))
            .on("pointerout", () => this.displaypeso.setScale(1))
            .on("pointerdown", () => this.w_escolhaPeso.show());
        this.add
            .text(101, 138, "MALE", {
                fontFamily: fontTxt2,
                align: "left",
            })
            .setTint(CORES.preto)
            .setOrigin(0.5)
            .setFontSize(12);
        this.add
            .text(226, 138, "FEMALE", {
                fontFamily: fontTxt2,
                align: "left",
            })
            .setTint(CORES.preto)
            .setOrigin(0.5)
            .setFontSize(12);
        this.add.image(1453, 120, "refeicao").setOrigin(0.5);
        this.add
            .text(1453, 45, "WITH MEAL?", {
                fontFamily: fontTxt2,
                align: "left",
            })
            .setTint(CORES.preto)
            .setOrigin(0.5)
            .setFontSize(12);
        this.bt_comrefeicao = new Button3(
            1454 - 40,
            205,
            70,
            40,
            "YES",
            this,
            () => this.mudaRefeicao(true),
            1
        );
        this.bt_semrefeicao = new Button3(
            1454 + 40,
            205,
            70,
            40,
            "NO",
            this,
            () => this.mudaRefeicao(false),
            1
        );
        this.w_escolhaPeso = new window_escolhaPeso(this);
        this.w_escolhaPeso.hide();
        this.w_escolhaBebida = new window_escolhaBebida(this);
        this.w_escolhaBebida.hide();
        //--------------------------
        for (var i = 0; i < this.timeline.length; i++) {
            this.listaObjCopos[i] = new Bebida(i, this, rect2);
        }
        this.grafico = new Grafico(this);
        // this.mudaGenero("H");
        // this.mudaPeso(73);
        // this.mudaRefeicao(false);
    }
    mudaPeso(peso) {
        var stringpeso = "";
        if (peso < 100) {
            stringpeso = "0" + String(peso);
        } else {
            stringpeso = String(peso);
        }
        this.var_peso = peso;
        let myFunc = (num) => Number(num);
        var intArr = Array.from(stringpeso, myFunc);
        this.displaypeso.setText(this.var_peso);
        this.w_escolhaPeso.mudaNumero(intArr[0], intArr[1], intArr[2]);
    }
    mudaRefeicao(arg) {
        if (this.var_refeicao == arg) {
            return false;
        } else {
            if (arg) {
                this.bt_comrefeicao.setFill();
                this.bt_semrefeicao.setUnfill();
            } else {
                this.bt_comrefeicao.setUnfill();
                this.bt_semrefeicao.setFill();
            }
            this.var_refeicao = arg;
        }
        this.grafico.update();
    }
    mudaGenero(arg) {
        if (this.var_genero == arg) {
            return false;
        } else {
            if (arg == "H") {
                this.bthomem.changespr(1);
                this.btmulher.changespr(2);
            } else {
                this.bthomem.changespr(2);
                this.btmulher.changespr(1);
            }
            this.var_genero = arg;
        }
        this.grafico.update();
    }
}
class window_escolhaPeso {
    constructor(scene) {
        this.scene = scene;
        this.fundo = scene.add
            .rectangle(
                0,
                0,
                config.scale.width,
                config.scale.height,
                0x000000,
                0.4
            )
            .setOrigin(0)
            .setInteractive({
                useHandCursor: true,
            })
            .on("pointerdown", () => this.fechaEatualiza());
        var w2 = config.scale.width * 0.5;
        var h2 = config.scale.height * 0.5;
        this.fundojanela = scene.add
            .rectangle(w2, h2, 386, 211, CORES.branco)
            .setOrigin(0.5);
        this.btup1 = new BTupdw(w2 - 64, h2 - 50, "bt_up1", scene, () =>
            this.changed("up", 1)
        );
        this.btup2 = new BTupdw(w2, h2 - 50, "bt_up1", scene, () =>
            this.changed("up", 2)
        );
        this.btup3 = new BTupdw(w2 + 64, h2 - 50, "bt_up1", scene, () =>
            this.changed("up", 3)
        );
        this.btdw1 = new BTupdw(w2 - 64, h2 + 50, "bt_down1", scene, () =>
            this.changed("down", 1)
        );
        this.btdw2 = new BTupdw(w2, h2 + 50, "bt_down1", scene, () =>
            this.changed("down", 2)
        );
        this.btdw3 = new BTupdw(w2 + 64, h2 + 50, "bt_down1", scene, () =>
            this.changed("down", 3)
        );
        var yy = h2;
        this.digito_100 = {
            x: w2 - 64,
            y: yy,
            numero: 0,
            imagem: scene.add.image(w2 - 64, yy, "d0").setOrigin(0.5),
        };
        this.digito_010 = {
            x: w2,
            y: yy,
            numero: 0,
            imagem: scene.add.image(w2, yy, "d0").setOrigin(0.5),
        };
        this.digito_001 = {
            x: w2 + 64,
            y: yy,
            numero: 0,
            imagem: scene.add.image(w2 + 64, yy, "d0").setOrigin(0.5),
        };
        this.contentor = this.scene.add.container(0, 0, [
            this.fundo,
            this.fundojanela,
            this.btup1,
            this.btup2,
            this.btup3,
            this.btdw1,
            this.btdw2,
            this.btdw3,
            this.digito_100.imagem,
            this.digito_010.imagem,
            this.digito_001.imagem,
        ]);
    }
    hide() {
        this.contentor.setVisible(false);
    }
    show() {
        this.contentor.setVisible(true);
        this.contentor.setDepth(100);
    }
    changed(dir, n) {
        switch (n) {
            case 1:
                if (dir == "up") {
                    this.digito_100.numero =
                        this.digito_100.numero >= 9
                            ? 0
                            : this.digito_100.numero + 1;
                    this.digito_100.imagem.destroy();
                    this.digito_100.imagem = this.scene.add
                        .image(
                            this.digito_100.x,
                            this.digito_100.y,
                            "d" + this.digito_100.numero
                        )
                        .setOrigin(0.5);
                    this.contentor.add(this.digito_100.imagem);
                } else {
                    this.digito_100.numero =
                        this.digito_100.numero <= 0
                            ? 9
                            : this.digito_100.numero - 1;
                    this.digito_100.imagem.destroy();
                    this.digito_100.imagem = this.scene.add
                        .image(
                            this.digito_100.x,
                            this.digito_100.y,
                            "d" + this.digito_100.numero
                        )
                        .setOrigin(0.5);
                    this.contentor.add(this.digito_100.imagem);
                }
                break;
            case 2:
                if (dir == "up") {
                    this.digito_010.numero =
                        this.digito_010.numero >= 9
                            ? 0
                            : this.digito_010.numero + 1;
                    this.digito_010.imagem.destroy();
                    this.digito_010.imagem = this.scene.add
                        .image(
                            this.digito_010.x,
                            this.digito_010.y,
                            "d" + this.digito_010.numero
                        )
                        .setOrigin(0.5);
                    this.contentor.add(this.digito_010.imagem);
                } else {
                    this.digito_010.numero =
                        this.digito_010.numero <= 0
                            ? 9
                            : this.digito_010.numero - 1;
                    this.digito_010.imagem.destroy();
                    this.digito_010.imagem = this.scene.add
                        .image(
                            this.digito_010.x,
                            this.digito_010.y,
                            "d" + this.digito_010.numero
                        )
                        .setOrigin(0.5);
                    this.contentor.add(this.digito_010.imagem);
                }
                break;
            case 3:
                if (dir == "up") {
                    this.digito_001.numero =
                        this.digito_001.numero >= 9
                            ? 0
                            : this.digito_001.numero + 1;
                    this.digito_001.imagem.destroy();
                    this.digito_001.imagem = this.scene.add
                        .image(
                            this.digito_001.x,
                            this.digito_001.y,
                            "d" + this.digito_001.numero
                        )
                        .setOrigin(0.5);
                    this.contentor.add(this.digito_001.imagem);
                } else {
                    this.digito_001.numero =
                        this.digito_001.numero <= 0
                            ? 9
                            : this.digito_001.numero - 1;
                    this.digito_001.imagem.destroy();
                    this.digito_001.imagem = this.scene.add
                        .image(
                            this.digito_001.x,
                            this.digito_001.y,
                            "d" + this.digito_001.numero
                        )
                        .setOrigin(0.5);
                    this.contentor.add(this.digito_001.imagem);
                }
                break;
            default:
                break;
        }
        var temp =
            String(this.digito_100.numero) +
            String(this.digito_010.numero) +
            String(this.digito_001.numero);
        this.scene.var_peso = Number(temp);
    }
    mudaNumero(d100, d010, d001) {
        this.digito_100.numero = d100;
        this.digito_100.imagem.destroy();
        this.digito_100.imagem = this.scene.add
            .image(
                this.digito_100.x,
                this.digito_100.y,
                "d" + this.digito_100.numero
            )
            .setOrigin(0.5);
        this.contentor.add(this.digito_100.imagem);
        this.digito_010.numero = d010;
        this.digito_010.imagem.destroy();
        this.digito_010.imagem = this.scene.add
            .image(
                this.digito_010.x,
                this.digito_010.y,
                "d" + this.digito_010.numero
            )
            .setOrigin(0.5);
        this.contentor.add(this.digito_010.imagem);
        this.digito_001.numero = d001;
        this.digito_001.imagem.destroy();
        this.digito_001.imagem = this.scene.add
            .image(
                this.digito_001.x,
                this.digito_001.y,
                "d" + this.digito_001.numero
            )
            .setOrigin(0.5);
        this.contentor.add(this.digito_001.imagem);
    }
    fechaEatualiza() {
        this.hide();
        if (this.scene.var_peso == undefined) {
            this.scene.var_peso = 0;
        }
        this.scene.displaypeso.setText(this.scene.var_peso);
        this.scene.grafico.update();
    }
}
class Bebida {
    constructor(num, scene, base_obj) {
        this.scene = scene;
        var offsetx = base_obj.x + 57;
        var offsety = base_obj.y + 58;
        var posx = offsetx + num * 92;
        if (num > 5) {
            offsety += 98;
            posx = offsetx + (num - 6) * 92;
        }
        var bg = this.scene.add
            .rectangle(0, 0, 77, 77, CORES.verdealface, 1)
            .setOrigin(0.5);
        var label = scene.add.text(0, 47, this.scene.timeline[num], {
            fontFamily: "GothamBook",
            color: "#000000",
        });
        label.setFontSize(12);
        label.setOrigin(0.5);
        this.item0 = scene.add.image(0, 0, "simboloMais").setOrigin(0.5);
        this.item1 = scene.add.image(0, 0, "copo_vinho").setOrigin(0.5);
        this.item2 = scene.add.image(0, 0, "cerveja").setOrigin(0.5);
        this.item3 = scene.add.image(0, 0, "shoot").setOrigin(0.5);
        this.hideItems();
        this.item0.setVisible(true);
        this.demosContainer = scene.add.container(posx, offsety, [
            bg,
            label,
            this.item0,
            this.item1,
            this.item2,
            this.item3,
        ]);
        bg.setInteractive({
            useHandCursor: true,
        });
        bg.on("pointerdown", () => this.click(num));
        bg.on("pointerover", () => this.demosContainer.setScale(1.1));
        bg.on("pointerout", () => this.demosContainer.setScale(1));
    }
    hideItems() {
        this.item0.setVisible(false);
        this.item1.setVisible(false);
        this.item2.setVisible(false);
        this.item3.setVisible(false);
    }
    click(num) {
        this.scene.var_index = num;
        this.scene.w_escolhaBebida.show();
    }
    changeBebida(num) {
        switch (num) {
            case 0:
                //nenhuma
                this.hideItems();
                this.item0.setVisible(true);
                break;
            case 1:
                //vinho
                this.hideItems();
                this.item1.setVisible(true);
                break;
            case 2:
                //cerveja
                this.hideItems();
                this.item2.setVisible(true);
                break;
            case 3:
                //bebida forte
                this.hideItems();
                this.item3.setVisible(true);
                break;
            default:
                break;
        }
        this.scene.grafico.update();
    }
}
class window_escolhaBebida {
    constructor(scene) {
        this.scene = scene;
        this.fundo = this.scene.add
            .rectangle(
                0,
                0,
                config.scale.width,
                config.scale.height,
                0x000000,
                0.4
            )
            .setInteractive();
        this.fundojanela = this.scene.add
            .rectangle(0, 0, 450, 300, CORES.branco)
            .setOrigin(0.5);
        var d = this.fundojanela.x - this.fundojanela.width * 0.5 - 60;
        var d1 = d + this.fundojanela.width / 4;
        var d2 = d1 + this.fundojanela.width / 4;
        var d3 = d2 + this.fundojanela.width / 4;
        var d4 = d3 + this.fundojanela.width / 4;
        var yy = this.fundojanela.y - 38;
        this.icon0 = this.scene.add
            .image(d1, yy, "simboloMais")
            .setTint(CORES.preto)
            .setOrigin(0.5);
        this.icon0.rotation = 0.785;
        this.icon1 = this.scene.add.image(d2, yy, "copo_vinho").setOrigin(0.5);
        this.icon2 = this.scene.add.image(d3, yy, "cerveja").setOrigin(0.5);
        this.icon3 = this.scene.add.image(d4, yy, "shoot").setOrigin(0.5);
        this.icon0.setInteractive({
            useHandCursor: true,
        });
        this.icon0.on("pointerdown", () => this.click(0));
        this.icon0.on("pointerover", () => this.icon0.setScale(1.1));
        this.icon0.on("pointerout", () => this.icon0.setScale(1));
        this.icon1.setInteractive({
            useHandCursor: true,
        });
        this.icon1.on("pointerdown", () => this.click(1));
        this.icon1.on("pointerover", () => this.icon1.setScale(1.1));
        this.icon1.on("pointerout", () => this.icon1.setScale(1));
        this.icon2.setInteractive({
            useHandCursor: true,
        });
        this.icon2.on("pointerdown", () => this.click(2));
        this.icon2.on("pointerover", () => this.icon2.setScale(1.1));
        this.icon2.on("pointerout", () => this.icon2.setScale(1));
        this.icon3.setInteractive({
            useHandCursor: true,
        });
        this.icon3.on("pointerdown", () => this.click(3));
        this.icon3.on("pointerover", () => this.icon3.setScale(1.1));
        this.icon3.on("pointerout", () => this.icon3.setScale(1));
        this.label0 = this.scene.add
            .text(this.icon0.x, this.icon0.y + 50, ["None"], {
                fontFamily: fontTxt2,
                align: "center",
            })
            .setTint(CORES.preto)
            .setOrigin(0.5, 0)
            .setFontSize(16);
        this.label1 = this.scene.add
            .text(this.icon1.x, this.icon1.y + 50, ["Wine", "(10 cl)"], {
                fontFamily: fontTxt2,
                align: "center",
            })
            .setTint(CORES.preto)
            .setOrigin(0.5, 0)
            .setFontSize(16);
        this.label2 = this.scene.add
            .text(this.icon2.x, this.icon2.y + 50, ["Beer", "(25 cl)"], {
                fontFamily: fontTxt2,
                align: "center",
            })
            .setTint(CORES.preto)
            .setOrigin(0.5, 0)
            .setFontSize(16);
        this.label3 = this.scene.add
            .text(
                this.icon3.x,
                this.icon3.y + 50,
                ["Strong", "alcoholic", "drink (3 cl)"],
                {
                    fontFamily: fontTxt2,
                    align: "center",
                }
            )
            .setTint(CORES.preto)
            .setOrigin(0.5, 0)
            .setFontSize(16);
        this.contentor = this.scene.add.container(
            config.scale.width * 0.5,
            config.scale.height * 0.5,
            [
                this.fundo,
                this.fundojanela,
                this.icon0,
                this.icon1,
                this.icon2,
                this.icon3,
                this.label0,
                this.label1,
                this.label2,
                this.label3,
            ]
        );
    }
    hide() {
        this.contentor.setVisible(false);
    }
    show() {
        this.contentor.setVisible(true);
        this.contentor.setDepth(100);
    }
    click(num) {
        switch (num) {
            case 0:
                this.scene.var_bebidasPerTempo[this.scene.var_index] = 0;
                break;
            case 1:
                //vinho
                this.scene.var_bebidasPerTempo[this.scene.var_index] = 1;
                break;
            case 2:
                //cerveja
                this.scene.var_bebidasPerTempo[this.scene.var_index] = 2;
                break;
            case 3:
                //bebida forte
                this.scene.var_bebidasPerTempo[this.scene.var_index] = 3;
                break;
            default:
                break;
        }
        this.scene.listaObjCopos[this.scene.var_index].changeBebida(
            this.scene.var_bebidasPerTempo[this.scene.var_index]
        );
        this.hide();
    }
}
class Grafico {
    constructor(scene) {
        this.scene = scene;
        this.dataPontos = [];
        this.graphics = 0;
        //this.offsetx = 22;
        this.offsetx = 0;
        this.offsety = 265;
        this.dEixoX = 75;
        this.dEixoY = 415;
        //this.tamanhoEixoX = 1401;
        this.tamanhoEixoX = 1515;
        this.tamanhoEixoY = 400;
        this.refZero = {
            x: this.offsetx + this.dEixoX,
            y: this.offsety + this.dEixoY,
        };
        this.dX = (this.tamanhoEixoX - this.dEixoX) / 24; //24 horas
        this.dX15mins = this.dX / 4;
        this.maxDoEixoYY = 2;
        this.taxaMax = 0;
        this.maxPixelsDoEixoXX = this.tamanhoEixoX;
        //var rectfundo_w = 1407;
        var rectfundo_w = 1525;
        var rectfundo_h = 469;
        this.linhasReferencia = [];
        //22, 265, 1407, 469
        var fundo = scene.add
            .rectangle(
                this.offsetx,
                this.offsety,
                rectfundo_w,
                rectfundo_h,
                0xffffff,
                0.8
            )
            .setOrigin(0);
        //EIXOS
        var eixoxx = scene.add.line(
            this.offsetx,
            this.offsety,
            this.dEixoX,
            this.dEixoY,
            this.tamanhoEixoX,
            this.dEixoY,
            0x000000
        );
        eixoxx.setOrigin(0);
        for (var i = 0; i < 25; i++) {
            var xx = this.offsetx + this.dEixoX + i * this.dX;
            var marca = scene.add.line(
                xx,
                this.offsety + this.dEixoY + 10,
                0,
                0,
                0,
                -10,
                0x000000
            );
            marca.setOrigin(0);
            var txt1 = scene.add
                .text(xx, marca.y + 10, i, {
                    fontFamily: "GothamBook",
                    fill: "#000000",
                    align: "right",
                })
                .setOrigin(0.5)
                .setFontSize(10);
        }
        var labeleixoxx = scene.add
            .text(xx - 10, this.offsety + this.dEixoY + 35, "horas", {
                fontFamily: "GothamBook",
                fill: "#000000",
                align: "right",
            })
            .setOrigin(1)
            .setFontSize(12);
        // eixo y --------------------------
        this.eixoYY = this.getEixoYY();
        var label_taxaMax = scene.add
            .text(
                this.offsetx + rectfundo_w * 0.75,
                this.offsety + rectfundo_h * 0.25,
                "Max ",
                {
                    fontFamily: "GothamBook",
                    fill: "#000000",
                    align: "right",
                }
            )
            .setOrigin(1)
            .setFontSize(16);
        this.txt_taxaMax = scene.add
            .text(
                this.offsetx + rectfundo_w * 0.76,
                this.offsety + rectfundo_h * 0.25,
                "0.0 g/l",
                {
                    fontFamily: "GothamBook",
                    fill: "#000000",
                    align: "left",
                }
            )
            .setOrigin(0, 1)
            .setFontSize(16);
    }
    getMaxOfArray(numArray) {
        return Math.max.apply(null, numArray);
    }
    widmark(q_etanol, t) {
        //var c; //quant.etanol(g)
        //var tempo = t; // horas
        var Vd = this.scene.var_genero == "H" ? 0.68 : 0.55;
        return q_etanol / (Vd * this.scene.var_peso) - this.scene.BETA * t;
    }
    getA_pr(q_etanol) {
        var Vd = this.scene.var_genero == "H" ? 0.68 : 0.55;
        return q_etanol / (Vd * this.scene.var_peso);
    }
    etanol(tipo) {
        var gramas;
        switch (tipo) {
            case 1:
                //vinho=1 -
                //gramas = 10;
                //gramas = 14.202;
                gramas = (150 * 12 * 0.8) / 100;
                break;
            case 2:
                //cerveja=2 -
                //gramas = 10;
                gramas = (250 * 5 * 0.8) / 100;
                break;
            case 3:
                //bebida forte=3 -
                //gramas = 10;
                //gramas = 15.78;
                gramas = (50 * 40 * 0.8) / 100;
                break;
            default:
                break;
        }
        return gramas;
    }
    clear() {
        this.eixoYY.eixoyy.destroy();
        this.eixoYY.labeleixoyy.destroy();
        for (var i = 0; i < this.eixoYY.numeros.length; i++) {
            this.eixoYY.numeros[i].destroy();
            this.eixoYY.marcas[i].destroy();
        }
        this.eixoYY = this.getEixoYY();
        for (var i = 0; i < this.dataPontos.length; i++) {
            this.dataPontos[i].destroy();
        }
        this.dataPontos = [];
        if (this.graphics) {
            this.graphics.destroy();
        }
        for (var i = 0; i < this.linhasReferencia.length; i++) {
            this.linhasReferencia[i].destroy();
        }
    }
    update() {
        if (this.scene.var_peso > 0) {
        } else {
            return false;
        }
        if (this.scene.var_refeicao == undefined) {
            return false;
        }
        if (this.scene.var_genero == undefined) {
            return false;
        }
        this.taxaMax = 0;
        /*
         */
        var A = 0;
        var A_pr = 0;
        var tempoPicoCom = 60;
        var tempoPicoSem = 40;
        var arrData = [];
        var arrDataDescontar = [];
        var arrDataFinal = [];
        var pico_alcoolemia = 0;
        var pico_alcoolemiaBase = 0;
        /*
         */
        var passoVertical = 0;
        //const ttotal = 24 * 4; // 15mins vezes 24 horas
        const ttotal = 24 * 60;
        var quantasBebidas = 0;
        for (let i = 0; i < ttotal; i++) {
            arrData[i] = 0;
            arrDataDescontar[i] = 0;
            arrDataFinal[i] = 0;
        }
        var listatemp = [];
        for (
            let index = 0;
            index < this.scene.var_bebidasPerTempo.length;
            index++
        ) {
            if (this.scene.var_bebidasPerTempo[index] == undefined) {
                listatemp[index] = 0;
            } else {
                listatemp[index] = this.scene.var_bebidasPerTempo[index];
                if (this.scene.var_bebidasPerTempo[index] > 0)
                    quantasBebidas += 1;
            }
        }
        listatemp.unshift(0);
        var comecaDescontar = 0;
        var converterBebidasHora = 0;
        var tempoTotalAnterior = 0;
        var tempoTotal = 0;
        for (let index = 1; index < listatemp.length; index++) {
            const element = listatemp[index];
            converterBebidasHora = (index - 1) * 15;
            if (element != 0) {
                if (this.scene.var_refeicao) {
                    A = this.etanol(element);
                    pico_alcoolemia +=
                        this.widmark(this.etanol(element), 1) * 0.7;
                    pico_alcoolemiaBase = this.widmark(
                        this.etanol(element),
                        0.66
                    );
                    var taxa_absorcao = pico_alcoolemiaBase / 0.66 / 2;
                    A_pr = taxa_absorcao + this.scene.BETA;
                    var tempo_eliminacao = A_pr / this.scene.BETA;
                    tempoTotalAnterior = tempoTotal;
                    tempoTotal = (index - 1) * 15 + tempoPicoCom;
                    if (comecaDescontar == 0) {
                        comecaDescontar = tempoTotal;
                    }
                    let c = 0;
                    var t = 0;
                    for (let i = converterBebidasHora; i <= tempoTotal; i++) {
                        if (tempoTotalAnterior - 1 < 0) {
                            t = 0;
                        } else {
                            t = tempoTotalAnterior - 1;
                        }
                        if (arrData[i - 1] < arrData[tempoTotalAnterior - 1])
                            t = 0;
                        let valorAux = taxa_absorcao * (c / 60);
                        if (i == tempoTotalAnterior) {
                            c = 0;
                            valorAux = taxa_absorcao * (c / 60);
                            arrData[i] = arrData[t] + valorAux;
                        } else if (i >= tempoTotalAnterior && i <= tempoTotal) {
                            arrData[i] += arrData[t] + valorAux;
                        } else {
                            arrData[i] += valorAux;
                        }
                        c = c + 1;
                    }
                } else {
                    A = this.etanol(element);
                    A_pr = this.getA_pr(this.etanol(element));
                    var tempo_eliminacao = A_pr / this.scene.BETA;
                    pico_alcoolemia = this.widmark(this.etanol(element), 0.66);
                    var taxa_absorcao = pico_alcoolemia / 0.66;
                    tempoTotalAnterior = tempoTotal;
                    tempoTotal = (index - 1) * 15 + tempoPicoSem;
                    if (comecaDescontar == 0) {
                        comecaDescontar = tempoTotal;
                    }
                    let c = 0;
                    var t = 0;
                    for (let i = converterBebidasHora; i <= tempoTotal; i++) {
                        if (tempoTotalAnterior - 1 < 0) {
                            t = 0;
                        } else {
                            t = tempoTotalAnterior - 1;
                        }
                        if (arrData[i - 1] < arrData[tempoTotalAnterior]) t = 0;
                        let valorAux = taxa_absorcao * (c / 60);
                        if (i == tempoTotalAnterior) {
                            c = 0;
                            valorAux = taxa_absorcao * (c / 60);
                            arrData[i] = arrData[t] + valorAux;
                        } else if (i >= tempoTotalAnterior && i <= tempoTotal) {
                            arrData[i] += arrData[t] + valorAux;
                        } else {
                            arrData[i] += valorAux;
                        }
                        c = c + 1;
                    }
                }
            }
        }
        var descontar = this.scene.BETA / 60;
        let x = 0;
        var alcoolMaximo = arrData[comecaDescontar];
        for (let j = comecaDescontar; j <= ttotal; j++) {
            if (arrData[j] == 0) {
                if (arrData[j - 1] > 0 && arrData[j + 1] > 0) {
                    arrData[j] = arrData[j - 1] + arrData[j + 1] - descontar;
                    x = j;
                } else {
                    arrData[j] = arrData[j - 1] - descontar;
                    x = 0;
                }
                if (arrData[j] < 0) {
                    arrData[j] = 0;
                }
            } else if (arrData[j + 1] == 0) {
                arrData[j] = arrData[j - 1] - descontar;
                x = j;
            } else if (x > 0 && j < tempoTotal) {
                arrData[j] = arrData[x] + arrData[j + 1] - descontar;
            } else if (x > 0 && j >= tempoTotal) {
                arrData[j] = arrData[tempoTotal - 1] - descontar;
            } else {
                arrData[j] -= descontar;
            }
            if (arrData[j] > alcoolMaximo) alcoolMaximo = arrData[j];
        }
        this.taxaMax = alcoolMaximo;
        this.clear();
        if (this.taxaMax > 2) {
            //recalcular eixo Y
            passoVertical = this.tamanhoEixoY / this.maxDoEixoYY;
        } else {
            passoVertical = this.tamanhoEixoY / 2;
        }
        //--------------------------------------------------------
        this.graphics = this.scene.add.graphics();
        this.graphics.lineStyle(2, 0x0000ea);
        this.graphics.beginPath();
        this.graphics.moveTo(this.refZero.x, this.refZero.y);
        for (var i = 1; i < arrData.length; i++) {
            var xx;
            if (this.scene.var_refeicao) {
                xx = this.refZero.x + i;
            } else {
                xx = this.refZero.x + i;
            }
            if (xx < this.tamanhoEixoX) {
                var yy = this.refZero.y - arrData[i] * passoVertical;
                this.graphics.lineTo(xx, yy);
            }
        }
        this.graphics.strokePath();
        this.graphics.closePath();
        this.txt_taxaMax.setText(this.taxaMax.toFixed(2) + " g/l");
        // linhas referencia -----------------
        // 0.2; 0.5; 0.8; 1.2
        var espessura = 0.15;
        var cor = 0x333333;
        this.linhasReferencia[0] = this.scene.add
            .line(
                this.offsetx,
                this.offsety,
                this.dEixoX,
                this.dEixoY - 0.2 * passoVertical,
                this.tamanhoEixoX,
                this.dEixoY - 0.2 * passoVertical,
                cor
            )
            .setOrigin(0)
            .setLineWidth(espessura);
        this.linhasReferencia[1] = this.scene.add
            .line(
                this.offsetx,
                this.offsety,
                this.dEixoX,
                this.dEixoY - 0.5 * passoVertical,
                this.tamanhoEixoX,
                this.dEixoY - 0.5 * passoVertical,
                cor
            )
            .setOrigin(0)
            .setLineWidth(espessura);
        this.linhasReferencia[2] = this.scene.add
            .line(
                this.offsetx,
                this.offsety,
                this.dEixoX,
                this.dEixoY - 0.8 * passoVertical,
                this.tamanhoEixoX,
                this.dEixoY - 0.8 * passoVertical,
                cor
            )
            .setOrigin(0)
            .setLineWidth(espessura);
        this.linhasReferencia[3] = this.scene.add
            .line(
                this.offsetx,
                this.offsety,
                this.dEixoX,
                this.dEixoY - 1.0 * passoVertical,
                this.tamanhoEixoX,
                this.dEixoY - 1.0 * passoVertical,
                cor
            )
            .setOrigin(0)
            .setLineWidth(espessura);
        this.linhasReferencia[4] = this.scene.add
            .line(
                this.offsetx,
                this.offsety,
                this.dEixoX,
                this.dEixoY - 1.5 * passoVertical,
                this.tamanhoEixoX,
                this.dEixoY - 1.5 * passoVertical,
                cor
            )
            .setOrigin(0)
            .setLineWidth(espessura);
    }
    getEixoYY() {
        var obj = {};
        obj.eixoyy = this.scene.add.line(
            this.offsetx,
            this.offsety,
            this.dEixoX,
            this.dEixoY,
            this.dEixoX,
            10,
            0x000000
        );
        obj.eixoyy.setOrigin(0);
        var lista;
        if (this.taxaMax > 2) {
            lista = [];
            var cc = Math.floor(this.taxaMax) + 1;
            var flag = true;
            var inc = 0;
            while (flag) {
                lista[inc] = inc * 0.5;
                inc++;
                if (inc * 0.5 > cc) flag = false;
            }
        } else {
            lista = [0, 0.2, 0.5, 0.8, 1, 1.5, 2];
        }
        this.maxDoEixoYY = this.getMaxOfArray(lista);
        obj.numeros = [];
        obj.marcas = [];
        for (var i = 0; i < lista.length; i++) {
            var Ya = (lista[i] * this.tamanhoEixoY) / this.maxDoEixoYY;
            var yy = this.offsety + this.dEixoY - Ya;
            obj.numeros[i] = this.scene.add
                .text(this.offsetx + 66, yy + 6, lista[i], {
                    fontFamily: "GothamBook",
                    fill: "#000000",
                    align: "right",
                })
                .setOrigin(1)
                .setFontSize(16);
            obj.marcas[i] = this.scene.add.line(
                this.offsetx + 70,
                yy,
                0,
                0,
                8,
                0,
                0x000000
            );
            obj.marcas[i].setOrigin(0, 0.5);
        }
        obj.labeleixoyy = this.scene.add
            .text(this.offsetx + 40, yy + 50, "g/l", {
                fontFamily: "GothamBook",
                fill: "#000000",
                align: "right",
            })
            .setOrigin(1)
            .setFontSize(18);
        return obj;
    }
}
